
# Basado en el plugin "WhatIs" de Jasper Huzen

namespace eval ::drae {
	proc init { dir }	{
		::plugins::RegisterPlugin "drae"
		::plugins::RegisterEvent "drae" new_chatwindow addButtons
		plugins_log "drae" "plugin registered"
	}
	
	proc getSelectedText { w } {
	   if { $::version == "0.94" } {
			set window $w.f.bottom.in.input
		
			if { [ catch {$window tag ranges sel}]} {
				set window $w
			}
		
			set index [$window tag ranges sel]
		
			if { $index == "" } {
				set window $w.f.out.text
				catch {set index [$window tag ranges sel]}
				if { $index == "" } {  return }
			}
		} else { 
			if { [ catch {set window [::ChatWindow::GetInputText $w]} ]} {
				set window $w
			}
			
			set index [$window tag ranges sel]
		
			if { $index == "" } {
				set window [::ChatWindow::GetOutText $w]
				catch {set index [$window tag ranges sel]}
				if { $index == "" } {  return }
			}
		}
			
		set dump [$window dump -text [lindex $index 0] [lindex $index 1]]
		
		if { $dump == "" } return
		
		foreach { text output index } $dump {
			append tpmVar $output
		}
		return $tpmVar  
	}
	
	proc addButtons { event evpar } {
		upvar 2 $evpar args
		plugins_log "drae" "Add buttons to window"
		set w $args(win)
		set copymenu $w.copy
		$copymenu add command -label "Diccionario RAE" -command "drae::drae $w"	
	}
	
	proc drae { w } {
		set searchText [getSelectedText $w]
		if { $searchText == "" } {
			::amsn::messageBox "No text selected!" ok error 
		} else { 
			set searchText [string tolower $searchText]
			catch {exec lynx --dump --nolist http://buscon.rae.es/draeI/SrvltGUIBusUsual?TIPO_HTML=2&LEMA=$searchText} output
			::amsn::WinWrite [::ChatWindow::Name $w] "\n" green
			if { $::version == "0.94" } {
					::amsn::WinWrite [::ChatWindow::Name $w] "--------------------------------------------------" gray_italic	 
			} else {
					::amsn::WinWriteIcon [::ChatWindow::Name $w] greyline 3 
			} 
			::amsn::WinWrite [::ChatWindow::Name $w] "\n$output\n" gray
			if { $::version == "0.94" } {
					::amsn::WinWrite [::ChatWindow::Name $w] "--------------------------------------------------\n" gray_italic	 
			} else {
					::amsn::WinWriteIcon [::ChatWindow::Name $w] greyline 3 
			} 
		}
	}

	proc deInit { } {
		::plugins::UnRegisterEvents "drae"
		plugins_log "drae" "plugin unregistered"
	}
} 
